TOOL.Category		= "Wire - Physics"
TOOL.Name			= "Fading Door"
TOOL.Command		= nil
TOOL.ConfigName		= ""
TOOL.ClientConVar[ "model" ] = "models/props_c17/door01_left.mdl"

if ( CLIENT ) then
    language.Add( "Tool_wire_fadingdoor_name", "Fading Door (Wire)" )
    language.Add( "Tool_wire_fadingdoor_desc", "Spawns a Fading Door" )
    language.Add( "Tool_wire_fadingdoor_0", "Primary: Create Fading Door. Secondary: Get Model" )
    language.Add( "WireDatafadingdoorTool_fadingdoor", "Fading Door:" )
	language.Add( "sboxlimit_wire_fadingdoors", "You've hit Fading Doors limit!" )
	language.Add( "undone_Wire fadingdoor", "Undone Wire Fading Door" )
end

if (SERVER) then
	CreateConVar('sbox_maxwire_fadingdoors', 20)
end

cleanup.Register( "wire_fadingdoors" )

function TOOL:LeftClick( trace )
	if (!trace.HitPos) then return false end
	if (trace.Entity:IsPlayer()) then return false end
	if ( CLIENT ) then return true end

	local ply = self:GetOwner()

	if ( trace.Entity:IsValid() && trace.Entity:GetClass() == "gmod_wire_fadingdoor" && trace.Entity:GetTable().pl == ply ) then
		return true
	end

	if ( !self:GetSWEP():CheckLimit( "wire_fadingdoors" ) ) then return false end

	local Ang = trace.HitNormal:Angle()
	Ang.pitch = Ang.pitch + 90
	
	local Model	= self:GetClientInfo( "model" )

	local wire_fadingdoor = MakeWireFadingDoor( ply, Model, trace.HitPos, Ang )

	local min = wire_fadingdoor:OBBMins()
	wire_fadingdoor:SetPos( trace.HitPos - trace.HitNormal * min.z )
		
	undo.Create("Wire fadingdoor")
		undo.AddEntity( wire_fadingdoor )
		undo.SetPlayer( ply )
	undo.Finish()

	ply:AddCleanup( "wire_fadingdoors", wire_fadingdoor )

	return true
end

function TOOL:RightClick( trace )
	if CLIENT and trace.Entity:IsValid() then return true end
	if not trace.Entity:IsValid() then return end
	local model = trace.Entity:GetModel()
	self:GetOwner():ConCommand("wire_fadingdoor_model "..model);
	self.Model = model
	return true;
end

if (SERVER) then

	function MakeWireFadingDoor( pl, Model, Pos, Ang )
		if ( !pl:CheckLimit( "wire_fadingdoors" ) ) then return false end
	
		local wire_fadingdoor = ents.Create( "gmod_wire_fadingdoor" )
		if (!wire_fadingdoor:IsValid()) then return false end

		wire_fadingdoor:SetAngles(Ang)
		wire_fadingdoor:SetPos(Pos)
		wire_fadingdoor:SetModel(Model)
		wire_fadingdoor:Spawn()

		wire_fadingdoor:SetPlayer( pl )

		local ttable = {
			pl = pl
		}

		table.Merge(wire_fadingdoor:GetTable(), ttable )
		
		pl:AddCount( "wire_fadingdoors", wire_fadingdoor )

		return wire_fadingdoor
	end
	
	duplicator.RegisterEntityClass("gmod_wire_fadingdoor", MakeWireFadingDoor, "Model", "Pos", "Ang", "Vel", "aVel", "frozen")

end

function TOOL:UpdateGhostWireFadingDoor( ent, player )
	if ( !ent || !ent:IsValid() ) then return end

	local tr 	= utilx.GetPlayerTrace( player, player:GetCursorAimVector() )
	local trace 	= util.TraceLine( tr )

	if (!trace.Hit || trace.Entity:IsPlayer() || trace.Entity:GetClass() == "gmod_wire_fadingdoor" ) then
		ent:SetNoDraw( true )
		return
	end

	local Ang = trace.HitNormal:Angle()
	Ang.pitch = Ang.pitch + 90

	local min = ent:OBBMins()
	ent:SetPos( trace.HitPos - trace.HitNormal * min.z )
	ent:SetAngles( Ang )

	ent:SetNoDraw( false )
end

function TOOL:Think()
	if (!self.GhostEntity || !self.GhostEntity:IsValid() || self.GhostEntity:GetModel() != self.Model ) then
		self:MakeGhostEntity( self:GetClientInfo("model"), Vector(0,0,0), Angle(0,0,0) )
	end

	self:UpdateGhostWireFadingDoor( self.GhostEntity, self:GetOwner() )
end

function TOOL.BuildCPanel(panel)

	panel:AddControl("Header", { Text = "#Tool_wire_fadingdoor_name", Description = "#Tool_wire_fadingdoor_desc" })
	
end
